package ims.coref.features;

import ims.coref.data.Document;
import ims.coref.data.PairInstance;

public class AbstractSingleBigramFeature extends AbstractSingleDataDrivenFeature{
	private static final long serialVersionUID = 1L;

	private final ISingleFeature f1;
	private final ISingleFeature f2;
	
	protected AbstractSingleBigramFeature(ISingleFeature f1,ISingleFeature f2, int cutOff) {
		super(f1.getName()+"+"+f2.getName(), cutOff);
		this.f1=f1;
		this.f2=f2;
	}

	@Override
	public String extractStringValue(PairInstance instance,Document d) {
		String s1=f1.getStringValue(instance,d);
		String s2=f2.getStringValue(instance,d);
		if(s1==null || s2==null)
			return null;
		return s1+"++"+s2;
	}

}
